import { isArray } from "@thi.ng/checks/is-array";
import { isProtoPath } from "@thi.ng/checks/is-proto-path";
import { isString } from "@thi.ng/checks/is-string";
import { assert } from "@thi.ng/errors/assert";
const toPath = (path) => isArray(path) ? path : isString(path) ? path.length > 0 ? path.split(".") : [] : path != null ? [path] : [];
const exists = (obj, path) => {
  if (obj == null) {
    return false;
  }
  path = toPath(path);
  for (let n = path.length - 1, i = 0; i <= n; i++) {
    const k = path[i];
    if (!obj.hasOwnProperty(k)) {
      return false;
    }
    obj = obj[k];
    if (obj == null && i < n) {
      return false;
    }
  }
  return true;
};
const disallowProtoPath = (path) => (assert(!isProtoPath(path), `unsafe path: '${path}'`), path);
export {
  disallowProtoPath,
  exists,
  toPath
};
